<?php

@include_once(dirname(__FILE__) . '/commons.php');
@include_once(dirname(__FILE__) . '/controls.php');

$plugin = $file_commerce;
$users = array();

// Process known actions. Some actions need to process the options, do something
// without storing them on the database but showing them to the user a second time.
if ($controls->is_action('delete')) {

    if (!file_commerce_pro_delete_contract_from_db($_POST['contractid'])) {
        $controls->errors = "Error deleting contract from database";
    }
    else {
        $controls->errors = "Contract correctly deleted from database.";
    }
}

// Search users who have email, id, login partially o totally matching the filter text
if ($controls->is_action('search'))
{
    $controls->options = stripslashes_deep($_POST['options']);
    // Save the search criteria for future use
    update_option($plugin->uid . '_contracts', $controls->options);

    $like_text = '%' . $controls->options['text'] . '%';
    $users = $wpdb->get_results($wpdb->prepare("select * from " . $wpdb->users . " where id=%s or user_email like %s or user_login like %s",
            $controls->options['text'], $like_text, $like_text));
}

if ($controls->options == null) $controls->options = get_option($plugin->uid . '_contracts');
?>

<div class="wrap">

    <h2><?php echo $plugin->title; ?>: Contracts Management</h2>

    <?php $controls->show_errors(); ?>

    <form method="post">
    <?php $controls->init(); ?>

    <h3>Customer search</h3>
    <p>Search for customer to manage their contracts.</p>
    <table class="form-table">
        <tr>
            <th>
                Search text
            </th>
            <td>
                <?php $controls->text('text', 70); ?>
                <?php $controls->button('search', 'Search'); ?>
            </td>
        </tr>
    </table>
    </form>

    <h3>Users found</h3>
    <table class="widefat">
        <thead>
            <tr>
                <th>Id</th><th>Login</th><th>Email</th><th>Contracts</th><th>&nbsp;</th>
            </tr>
        </thead>
        <tbody>
        <?php foreach ($users as $u) { ?>
        <tr>
            <td><?php echo $u->ID; ?></td>
            <td><?php echo $u->user_login; ?></td>
            <td><?php echo $u->user_email; ?></td>
            <td>
                <?php
                    $query = $wpdb->prepare("select c.id, c.status, c.expire from " . $wpdb->prefix . FILECOMMERCE_TABLE_CONTRACTS . " c where c.userid=" . $u->ID . " order by c.expire desc");
                    $contracts = $wpdb->get_results($query);
                ?>

                <?php foreach ($contracts as $c) { ?>
                    <a href="?page=file-commerce/contracts_edit.php&amp;id=<?php echo $c->id; ?>">edit</a> - <?php echo date('Y-m-d', $c->expire); ?> - <?php echo $c->status; ?><br />
                <?php } ?>
            </td>
            <td>
                <a href="?page=file-commerce/contracts_add.php&amp;userid=<?php echo $u->ID; ?>">Add a new contract</a>
            </td>
        </tr>
        <?php } ?>
        </tbody>
    </table>

</div>