<?php

include '../../../wp-load.php';

function file_commerce_paypal_verify() {
    global $file_commerce;

    $post_body = 'cmd=_notify-validate&';
    foreach ($_POST as $name => $value) {
        $post_body .= $name . '=' . urlencode(stripslashes($value)) . '&';
    }
    $post_body = substr($post_body, 0, -1);
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $file_commerce->paypal_url);
    curl_setopt($ch, CURLOPT_VERBOSE, 1);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $post_body);
    $response = curl_exec($ch);
    $file_commerce->log_debug($response);
    if ($response === 'VERIFIED') return true;
    else return false;
}

if (!isset($_POST['txn_id'])) return;

$file_commerce->log_debug($_POST);

if (!file_commerce_paypal_verify()) {
    $file_commerce->log_error('Paypal IPN unverified');
    die();
}

if (strpos(strtolower($file_commerce->get_option('paypal_email')), strtolower($_POST['receiver_email'])) === false) {
    $file_commerce->log_error('PayPal receiver email does not match, hack attempt?');
    die();
}

file_commerce_save_ipn($_POST['custom'], $_POST['item_number'], FileCommerce::GATEWAY_PAYPAL, serialize($_POST), '', serialize($_SERVER), $_POST['txn_id']);

switch ($_POST['payment_status']) {
    case 'Completed':
        $txnid = $_POST['txn_id'];
        $contract = $wpdb->get_row($wpdb->prepare("select * from " . $wpdb->prefix . FILECOMMERCE_TABLE_CONTRACTS . " where gateway='" . FileCommerce::GATEWAY_PAYPAL . "' and txnid=%s", $txnid), ARRAY_A);

        if (!empty($contract) && $contract['status'] == FileCommerce::CONTRACT_VALID) {
            $file_commerce->log_error('Duplicated IPN, contract already in paid status');
            die();
        }

        // There is no contract for this transaction
        if (empty($contract)) {
            $contract = array();

            $contract['userid'] = $_POST['custom'];
            $contract['status'] = FileCommerce::CONTRACT_INVALID;
            $contract['gateway'] = FileCommerce::GATEWAY_PAYPAL;
            $contract['txnid'] = $txnid;
        }

        $contract['expire'] = $file_commerce->get_contract_expiration_value($file->duration);
        $contract['status'] = FileCommerce::CONTRACT_VALID;

        if (empty($contract['id'])) {
            $wpdb->insert($wpdb->prefix . FILECOMMERCE_TABLE_CONTRACTS, $contract);
            $contract['id'] = $wpdb->insert_id;
        }
        else {
            // Should not the case
            $id = $contract['id'];
            unset($contract['id']);
            $wpdb->update($wpdb->prefix . FILECOMMERCE_TABLE_CONTRACTS, $contract, array('id' => $id));
            $contract['id'] = $id;
        }

        $file_commerce->notify_new_contract($contract);

        die();
        break;

    case 'Reversed':
    case 'Refunded':
        $txnid = $_POST['parent_txn_id'];
        $contract = $wpdb->get_row($wpdb->prepare("select * from " . $wpdb->prefix . FILECOMMERCE_TABLE_CONTRACTS . " where gateway='" . FileCommerce::GATEWAY_PAYPAL . "' and txnid=%s", $txnid), ARRAY_A);
        if (empty($contract)) {
            $file_commerce->log_error('Contract not found.');
            die();
        }
        $wpdb->update($wpdb->prefix . FILECOMMERCE_TABLE_CONTRACTS, array('status' => FileCommerce::CONTRACT_INVALID), array('id' => $contract['id']));
        $file_commerce->notify_invalidated_contract($contract);
        die();
        break;

    case 'Failed':
        break;

    case 'Canceled_Reversal':
        $txnid = $_POST['parent_txn_id'];
        $contract = $wpdb->get_row($wpdb->prepare("select * from " . $wpdb->prefix . FILECOMMERCE_TABLE_CONTRACTS . " where gateway='" . FileCommerce::GATEWAY_PAYPAL . "' and txnid=%s", $txnid), ARRAY_A);
        if (empty($contract)) {
            $file_commerce->log_error('Contract not found.');
            die();
        }
        $wpdb->update($wpdb->prefix . FILECOMMERCE_TABLE_CONTRACTS, array('status' => FileCommerce::CONTRACT_VALID), array('id' => $contract['id']));
        die();
        break;

    case 'Created':
    case 'Denied': // Prevously pending
    case 'Expired': // ???
    case 'Processed':
    case 'Voided':
        break;
}
die();
?>
